

import {Component} from '@angular/core';
import {IonicPage, NavController, NavParams, ToastController, App} from 'ionic-angular';
import {AuthService} from "../../providers/auth-service";
import { PosPenjualan } from '../pos-penjualan/pos-penjualan';

@IonicPage()
@Component({
  selector: 'page-bayar-kredit',
  templateUrl: 'bayar-kredit.html',
})
export class BayarKreditPage {
    isenabled: boolean = false;
    public resposeData: any;
    public nomor_kartu = '';
    mask = [/\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
    public recartData: any;
    public cartData: any;
    private mastercard: string = "automation-list-item checkbox-list item";
    private visa: string = "automation-list-item checkbox-list item";
    /*mengambil data sebelumnya */
    total_item: string;
    cart_id: string;
    username: string;
    Deskripsi: string;
    nama_pelanggan: string;
    catatan: string;
    diskon: string;
    grand_total: number;
    jumlah_diskon_rupiah: number;
    jumlah_diskon: number;
    promo: string;
    pajak: number;
    total: number;
    quantity: number;
    price: number;
    userCart = {
        cart_id: "",
        id_pelanggan: "",
        nama_pelanggan: "",
        username: "",
        ItemID: "",
        token: "",
        cart_item_id: "",
        catatan: "",
        diskon: "",
        diskon_persen: 0,
        jumlah_diskon: 0,
        promo: "",
        ppn: 0,
        ppn_rupiah:0,
        total_item: "",
        payment: "",
        provider: "",
        payment_number: "",
        payment_atachment: "",
        dibayar: 0,
        kembalian: 0,
        total: 0,
    }

    constructor(public navCtrl: NavController,
        public navParams: NavParams,
        private toastCtrl: ToastController,
        public authService: AuthService,
        private app: App) {
        this.navParams = navParams;
        this.userCart = this.navParams.data;

        this.userCart.payment = "KARTU KREDIT";
        this.userCart.payment_number = "-";

        /*hanya untuk pembayaran tunai*/
        this.userCart.dibayar = 0;
        this.userCart.kembalian = 0;

        this.getCart();
        this.getSummary();
    }

    getPaymentMastercard() {
        this.mastercard = "automation-list-item checkbox-list item selected";
        this.visa = "automation-list-item checkbox-list item";
        this.userCart.provider = "Mastercard";
        this.isenabled = true;
    }
    getPaymentVisa() {
        this.mastercard = "automation-list-item checkbox-list item";
        this.visa = "automation-list-item checkbox-list item selected";
        this.userCart.provider = "Visa";
        this.isenabled = true;
    }
    
    getSummary() {
        this.authService.postData(this.userCart, "getSummary").then(
            result => {
                this.recartData = result;
                if (this.recartData.summaryData) {
                    this.cartData = this.recartData.summaryData;
                    this.userCart.cart_id = this.cartData[0].cart_id;
                    this.userCart.total_item = this.cartData[0].total_item;
                    this.userCart.total = this.cartData[0].total;
                    this.userCart.username = this.userCart.username;
                    this.total_item = this.cartData[0].total_item;
                    this.total = this.cartData[0].total;
                    this.hitung_diskon();
                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    getCart() {
        this.authService.postData(this.userCart, "getCart").then(
            result => {
                this.recartData = result;
                if (this.recartData.cartData) {
                    this.cartData = this.recartData.cartData;
                    this.userCart.cart_id = this.cartData[0].cart_id;
                    this.userCart.id_pelanggan = this.cartData[0].id_pelanggan;
                    this.nama_pelanggan = this.cartData[0].nama_depan + " " + this.cartData[0].nama_belakang;
                    this.catatan = this.userCart.catatan;
                    this.userCart.ppn = this.userCart.ppn;
                    if (this.userCart.promo) {
                        this.promo = this.userCart.promo;
                    } else {
                        this.promo = "-"
                    }

                }
            },
            err => {
                this.presentToast("Gagal terhubung ke server.");
            }
        );
    }
    insertPenjualan(){
        this.userCart.payment = "KREDIT"; 
        this.userCart.dibayar = this.userCart.total;
        this.userCart.kembalian = 0;
        if (this.userCart.cart_id) {
            this.authService.postData(this.userCart, "insertPenjualan").then(
                result => {
                    this.resposeData = result;
                    if (this.resposeData.cartData) {
                         this.app.getRootNav().setRoot(PosPenjualan);
                        setTimeout(() => {
                        }, 150);
                    }
                },
                err => {
                    this.presentToast("Gagal terhubung ke server.");
                }
            );
        } else {
            this.presentToast("Gagal mengambil produk.");
        }
    }
    simpan_email() {
        if (this.userCart.payment_number === "") {
            this.presentToast("Silahkan pilih nama Bank dan masukan nomor kartu terlebih dahulu");
        } else {
            this.insertPenjualan();
        }
    }

    simpan_cetak() {
        if (this.userCart.payment_number === "") {
            this.presentToast("Silahkan pilih nama Bank dan masukan nomor kartu terlebih dahulu");
        } else {
            this.insertPenjualan();
        }
    }

    hitung_diskon() {
        if (this.userCart.diskon === 'IDR') {
            this.jumlah_diskon_rupiah = (this.userCart.jumlah_diskon / this.total) * 100;
            this.diskon = parseFloat("" + this.jumlah_diskon_rupiah.toFixed(2)) + "%";
            this.jumlah_diskon = this.total * this.jumlah_diskon_rupiah / 100;
            this.jumlah_diskon = parseFloat("" + this.jumlah_diskon.toFixed(0));
            this.userCart.ppn_rupiah = this.total * this.userCart.ppn / 100;
            this.grand_total = (this.total - this.jumlah_diskon) + this.userCart.ppn_rupiah;
            this.userCart.diskon_persen = this.jumlah_diskon_rupiah;
            this.userCart.dibayar = this.grand_total;
        } else {
            this.userCart.diskon === 'Persen'
            this.diskon = this.userCart.jumlah_diskon + "%";
            this.jumlah_diskon = this.total * this.userCart.jumlah_diskon / 100;
            this.userCart.ppn_rupiah = this.total * this.userCart.ppn / 100;
            this.grand_total = (this.total - this.jumlah_diskon) + this.userCart.ppn_rupiah;
            this.userCart.diskon_persen = this.jumlah_diskon;
            this.userCart.dibayar = this.grand_total;
        }
    }
    
    presentToast(msg) {
        let toast = this.toastCtrl.create({
            message: msg,
            duration: 3000
        });
        toast.present();
    }
}
